#pragma once

#ifndef C_GDENTRY_H
#define C_GDENTRY_H

#include <string>
#include <sstream>

#include "gdtypes.h"
#include "IGDEntry.h"
#include "gdentrytypes.h"
#include "gdentrystruct.h"

using namespace std;

template<typename T>
class GDLIBAPI GDEntry : public IGDEntry<T>
{ };

template<>
class GDEntry<gdFixation>:
	public IGDEntry<gdFixation>
{
public:
	GDEntry(gdFixation entry):IGDEntry<gdFixation>(entry) { }
	virtual ~GDEntry() { }

	virtual gdElementType type(){ return GDT_FIXATION; }
	virtual long duration(){ return mData.duration; }
	virtual short eye(){ return mData.eye; }
	virtual long x(){ return mData.x; }
	virtual long y(){ return mData.y; }
	virtual long number(){ return mData.number; }
	virtual long time(){ return mData.time; }

	virtual string toString()
	{
		stringstream stream;

		stream << time() << "\t";
		stream << number() << "\t";
		stream << x() << "\t";
		stream << y() << "\t";
		stream << duration() << "\t";
		stream << eye() << "\t";
		stream << -1 << "\t";
		stream << type() << "\t";
  
		return stream.str();
	}
};

template<>
class GDEntry<gdSingleSample>:
	public IGDEntry<gdSingleSample>
{
public:
	GDEntry(gdSingleSample entry):IGDEntry<gdSingleSample>(entry) { }
	virtual ~GDEntry() { }

	virtual gdElementType type(){ return GDT_FIXATION; }
	virtual long pupil(){ return mData.pupil; }
	virtual short eye(){ return mData.eye; }
	virtual long x(){ return mData.x; }
	virtual long y(){ return mData.y; }
	virtual long number(){ return mData.number; }
	virtual long time(){ return mData.time; }

	virtual string toString()
	{
		stringstream stream;

		stream << time() << "\t";
		stream << number() << "\t";
		stream << x() << "\t";
		stream << y() << "\t";
		stream << -1 << "\t";
		stream << eye() << "\t";
		stream << pupil() << "\t";
		stream << type() << "\t";
  
		return stream.str();
	}
};

template<>
class GDEntry<gdBlink>:
	public IGDEntry<gdBlink>
{
public:
	GDEntry(gdBlink entry):IGDEntry<gdBlink>(entry) { }
	virtual ~GDEntry() { }

	virtual gdElementType type(){ return GDT_BLINK; }
	virtual long duration(){ return mData.duration; }
	virtual short eye(){ return mData.eye; }
	virtual long number(){ return mData.number; }
	virtual long time(){ return mData.time; }

	virtual string toString()
	{
		stringstream stream;

		stream << time() << "\t";
		stream << number() << "\t";
		stream << -1 << "\t";
		stream << -1 << "\t";
		stream << duration() << "\t";
		stream << eye() << "\t";
		stream << -1 << "\t";
		stream << type() << "\t";
  
		return stream.str();
	}
};

#endif