#pragma once

#ifndef GDENTRYSTRUCT_H
#define GDENTRYSTRUCT_H

#include "gdtypes.h"

/**
 * Eye enumeratian used in gaze data entries.
 */
typedef enum _gdEye
{
	GDE_UNDEFINED = 999,
	GDE_LEFT = 0,
	GDE_RIGHT = 1
} gdEye;

/**
 * Single Sample gaze data for one eye.
 */
typedef struct _gdSingleSample
{
	CARD32 number;		//ordinal number
	CARD32 time;		//time offset from the start of the record
	CARD16 eye;			//event code
	CARD32 x;			//x coordinate of the eye
	CARD32 y;			//y coordinate of the eye
	CARD32 pupil;		//pupil size
} gdSingleSample;

#define sz_gdSingleSample 22

/**
 * Fixation gaze data.
 */
typedef struct _gdFixation
{
	CARD32 number;		//ordinal number
	CARD32 time;		//time offset from the start of the record
	CARD32 duration;	//fixation duration
	CARD16 eye;			//eye number
	CARD32 x;			//x coordinate of the eye
	CARD32 y;			//y coordinate of the eye
} gdFixation;

#define sz_gdFixation 22

/**
 * Blink gaze data.
 */
typedef struct _gdBlink
{
	CARD32 number;		//ordinal number
	CARD32 time;		//time offset from the start of the record
	CARD32 duration;	//fixation duration
	CARD16 eye;			//eye number
} gdBlink;

#define sz_gdBlink 14

#endif