#pragma once

#include <boost\shared_ptr.hpp>
#include <sstream>
#include <fstream>

#include "logrecordtypes.h"
#include "CGDTimestamp.h"

using namespace std;

typedef short vncClientId;

class CGDLogger
{
public:
	CGDLogger(string outFolder);
	virtual ~CGDLogger(void);

private:
	virtual void print(stringstream& ss, bool printTime = true);
	virtual void printHeader();
	virtual void printFooter();

public:
	virtual void open(string fileName, vncClientId cId);
	virtual void close();

	virtual bool isReady();
	virtual void setRecordStartToken(CGDTimestamp recordstart);

	virtual void log(gdLogRecordType logType, const string msg, string err = "");

private:
	std::string mOutputFolder;
	std::string mFileName;
	std::ofstream mOutStream;

	std::stringstream mRecStartToken;

	vncClientId mId;

	long mCount;

	string mFiller;
};


