#pragma once

#ifndef CGDTIMESTAMP_H
#define CGDTIMESTAMP_H

#ifdef _WIN32
#include <ctime>
#endif

#include <ostream>

using namespace std;

/**
 * Timestamp class
 */
struct CGDTimestamp
{
	unsigned short Year;		//current year
	unsigned int Days;			//days past since January 1st
	unsigned long Milliseconds;	//Milliseconds past since 00:00 for the current day

public:
	CGDTimestamp()
	{
#ifdef _WIN32
		time_t systime(0);
		tm t;
		gmtime_s(&t, &systime);
	
		Year = t.tm_year;
		Days = t.tm_yday;
		Milliseconds = (t.tm_hour*3600 + t.tm_min*60 + t.tm_sec) * 1000;
#else
		/**In case of NON-win32 code should fullfilled to set correctly timestamp*/
		Year = 0;
		Days = 0;
		Milliseconds = 0;
#endif
	}

	CGDTimestamp(unsigned short Y, unsigned int D, unsigned long M):
		Year(Y), Days(D), Milliseconds(M)
	{}

	friend ostream &operator<<(ostream &stream, CGDTimestamp ts)
	{
		stream << ts.Year << "-";
		stream << ts.Days << "-";
		stream << ts.Milliseconds;
  
		return stream;
	}
};

#endif