/**
 * etiproto_c2s.h - header file defining gaze data specific client to server messages
 */

#pragma once
#ifndef GDPROTO_C2S_H
#define GDPROTO_C2S_H

#include "gdtypes.h"

//Gaze Data messages
#define gdClientGazeSample			251	//send new eye tracking sample
#define gdClientGazeFixation		252	//send new eye tracking fixation
#define gdClientGazeBlink			253	//send new eye tracking blink

//Client "control" messages
#define gdClientNickname			254	//send new nickname
#define gdClientDescription			255	//send new description
#define gdClientTxtMessage			256	//send text message

#define gdClientReg					257	//send add client to the tracking list
#define gdClientUnReg				258	//send remove client from the tracking list
#define gdClientPoke				259	//send poke

/*-----------------------------------------------------------------------------
 * gdClientHdrMsg - Send header message that contains.
 *
 * This message holds source Id and amount of data entries, that follows this header.
 * Type of the data that follows this header depend on the type of the message.
 */
struct gdClientHdrMsg {
    CARD8 type;			// gdClientGazeSample | gdClientGazeFixation | gdClientGazeBlink | gdClientNickname | gdClientDescription | gdClientMessage | gdClientReg | gdClientUnReg | gdClientPoke
    CARD8 reserved1;
	CARD16 id;			//destination Id
	CARD16 reserved2;
	CARD16 count;		//amount of following data entries
};

#define sz_gdServerHdrMsg 8

#endif
