/**
 * etiproto_s2c.h - header file defining gaze data specific server to client messages
 */

#pragma once

#ifndef GDPROTO_S2C_H
#define GDPROTO_S2C_H

#include "gdtypes.h"

//Gaze Data messages
#define gdServerGazeSample			201	//send new eye tracking sample
#define gdServerGazeFixation		202	//send new eye tracking fixation
#define gdServerGazeBlink			203	//send new eye tracking blink

//Client "control" messages
#define gdServerNickname			204	//send new nickname
#define gdServerDescription			205	//send new description
#define gdServerTxtMessage			206	//send text message to the client

#define gdServerReg					207	//send add client to the tracking list
#define gdServerUnReg				208	//send remove client from the tracking list
#define gdServerPoke				209	//send client poke

/*-----------------------------------------------------------------------------
 * gdServerHdrMsg - Send header message from server to the client
 *
 * This message holds source Id and amount of data entries, that follows this header.
 * Type of the data that follows this header depend on the type of the message.
 */
struct gdServerHdrMsg {
    CARD8 type;			// gdServerGazeSample | gdServerGazeFixation | gdServerGazeBlink | gdServerNickname | gdServerDescription | gdServerMessage | gdServerReg | gdServerUnReg | gdServerPoke
    CARD8 reserved1;
	CARD16 id;			//source Id
	CARD16 reserved2;
	CARD16 count;		//amount of following data entries
};

#define sz_gdServerHdrMsg 8

#endif