#include "CGDVncServer.h"

void CGDVncServer::setLogFolder(std::string logFolder)
{
	if (logFolder.empty())
		logFolder = DEFAULT_LOG_FOLDER;

	if (mLogFolder.empty())
		mLogFolder = logFolder;
}

void CGDVncServer::distRegRequest(vncClientId id, LPSTR nickname, std::string description)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendRegRequest(id, nickname, description);
	}
}

void CGDVncServer::distUnRegRequest(vncClientId id)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendUnRegRequest(id);
	}
}

void CGDVncServer::distGDSingleSample(vncClientId id, std::list<gdSingleSample> samples)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendGDSingleSample(id, samples);
	}
}

void CGDVncServer::distGDBlink(vncClientId id, std::list<gdBlink> blinks)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendGDBlink(id, blinks);
	}
}

void CGDVncServer::distGDFixation(vncClientId id, std::list<gdFixation> fixations)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendGDFixation(id, fixations);
	}
}

void CGDVncServer::distPoke(vncClientId id)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendPoke(id);
	}
}

void CGDVncServer::distTextMessage(vncClientId id, std::string msg)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendTextMessage(id, msg);
	}
}

void CGDVncServer::distNickname(vncClientId id, std::string nickname)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendNickname(id, nickname);
	}
}

void CGDVncServer::distDescription(vncClientId id, std::string description)
{
	vncClientList::iterator i;
	omni_mutex_lock l(m_clientsLock);

	for (i = m_authClients.begin(); i != m_authClients.end(); i++)
	{
		vncClient* c = GetClient(*i);

		if (c != NULL && c->isRegistered())
			c->sendDescription(id, description);
	}
}