#pragma once

#include "winvnc\stdhdrs.h"

#include "winvnc\omnithread\omnithread.h"
#include "winvnc\vncClient.h"

#include "gdtypes.h"

class CGDVncServer1
{
protected:
	void setLogFolder(std::string logFolder);

public:
	//compatability with base project
	virtual vncClient* GetClient(vncClientId clientid) = 0;

	void distRegRequest(vncClientId id, LPSTR nickname, std::string description);
	void distUnRegRequest(vncClientId id);

	void distGDSingleSample(vncClientId id, std::list<gdSingleSample> samples);
	void distGDBlink(vncClientId id, std::list<gdBlink> blinks);
	void distGDFixation(vncClientId id, std::list<gdFixation> fixations);

	void distPoke(vncClientId id);
	void distTextMessage(vncClientId id, std::string msg);

	void distNickname(vncClientId id, std::string nickname);
	void distDescription(vncClientId id, std::string description);

public:
	CGDVncServer1(){ }
	virtual ~CGDVncServer1(){ }

protected:
	/*
	 * Compatability with base project
	 */
	omni_mutex	m_clientsLock;
	vncClientList m_authClients;

	std::string mLogFolder;
};

