/*<ETI>*/

/*-----------------------------------------------------------------------------
 * Structure used to specify eye-tracking information. Position, color, 
 * switchable flag. Switchable flag define if the client can turn off eye-tracking 
 * info from this source.
 * eti - eye-tracking information.
 */
#include "vncClient.h"
#include "rfb.h"

#ifndef ETI_H_
#define ETI_H_

/**
 * One eye-tracking item. Coordinates in client id
 */
typedef struct _etiItem {
    CARD16 x;
    CARD16 y;
	CARD16 id; //client Id
} etiItem;

#define sz_etiItem 6

/**
 * Description of one client - id, color, show flag
 */
typedef struct _etiClient {
	CARD8 swFlag; //show client info. not used
	CARD16 R;	//red component. not used
	CARD16 G;	//green component. not used
	CARD16 B;	//blue component. not used
	CARD16 A;	//alfa channel (trancparency). not used
	vncClientId id; //client Id
} etiClient;

#define sz_etiClient 11

//Map of clients
typedef std::map<vncClientId, etiClient> vncEYEClientsMap;

//Map of eye tracking info points
typedef std::map<vncClientId, etiItem> vncEYEPosMap;

#endif

/*</ETI>*/